﻿window.addEventListener("resize", () => {
    updateDpiDependentStyles();
});

let styleContainer;

function updateDpiDependentStyles() {
    if (!styleContainer) {
        styleContainer = document.createElement("style");
        document.head.appendChild(styleContainer);
    }

    let dpi = window.devicePixelRatio
    let isChromium = navigator.userAgentData?.brands?.some(data => data.brand == 'Chromium') || navigator.userAgent.indexOf("Chrome") >= 0;

    let style = "";
    let stroke;
    for (let t = 1; t <= 8; t++) {
        stroke = (t / dpi).toFixed(3);
        if (dpi >= 2)
            stroke *= 2;
        if (isChromium)
            stroke -= 0.001;
        
        style += `svg .px-${t} {stroke-width: ${stroke}px; } `;
    }

    stroke = (1 / dpi).toFixed(3);
    if (isChromium)
        stroke -= 0.001;

    style += `svg .nodeBorder {stroke-width: ${stroke}px; } `;
    styleContainer.innerHTML = style;
}

updateDpiDependentStyles();