﻿var dragging = false;

window.addEventListener("dragstart", e => {
    dragging = true;
    setTimeout(() => {
        if (!dragging)
            return;

        let frameTabList = getParentWithFilter(e.target, n => n.classList && n.classList.contains("frameTabList"));
        if (frameTabList) {
            let child = frameTabList.firstElementChild;
            if (child && child.classList)
                child.classList.add("dragging");
        }
    });
});

window.addEventListener("dragend", e => {
    dragging = false;
    clearDragging();
}, true);

window.addEventListener("pointermove", e => {
    if (dragging) {
        dragging = false;
        clearDragging();
    }
}, true);

function clearDragging() {
    let dragOwners = document.getElementsByClassName("dragging");
    for (let element of dragOwners)
        element.classList.remove("dragging");
}