﻿var suggestionsElement, functionTipsElement, inputElement;

window.applyInputAids = function (element, suggestions, functionTips) {
    if (element !== inputElement) {
        hideInputAids();
    }

    if (element === document.activeElement) {
        if (element && suggestions) {
            if (!suggestionsElement) {
                suggestionsElement = document.createElement("ul");
                suggestionsElement.className = "suggestionsList";
                showPopup(suggestionsElement, () => {
                    setPopupPosition(suggestionsElement, { element: element });
                });
            }

            applyItems(suggestionsElement, suggestions);

            let selectedItem = suggestionsElement.getElementsByClassName("selected")[0];
            if (selectedItem) {
                selectedItem.scrollIntoView();
            }
        }
        else if (suggestionsElement) {
            suggestionsElement.parentNode.removeChild(suggestionsElement);
            suggestionsElement = null;
        }

        if (element && functionTips) {
            if (!functionTipsElement) {
                functionTipsElement = document.createElement("div");
                functionTipsElement.className = "functionLabel";
                showPopup(functionTipsElement, () => {
                    setPopupPosition(functionTipsElement, { element: element, placement: "above" });
                });
            }

            virtualDom.apply([functionTips], functionTipsElement);
        }
        else if (functionTipsElement) {
            functionTipsElement.parentNode.removeChild(functionTipsElement);
            functionTipsElement = null;
        }

        inputElement = element;
    }
};

window.suggestionsListOpen = function (element) {
    return document.getElementsByClassName("suggestionsList").length > 0;
};

window.addEventListener("pointerdown", event => {
    if (isSelfOrAnscestorOf(suggestionsElement, event.target)) {
        event.preventDefault();
    }
});

window.onBlurTextbox = target => {
    if (target === inputElement) {
        hideInputAids();
    }
};

function hideInputAids() {
    if (suggestionsElement) {
        suggestionsElement.parentNode.removeChild(suggestionsElement);
        suggestionsElement = null;
    }

    if (functionTipsElement) {
        functionTipsElement.parentNode.removeChild(functionTipsElement);
        functionTipsElement = null;
    }

    inputElement = null;
}

function applyItems(element, items) {
    virtualDom.apply(items.map(item => ({
        type: "li",
        properties: {class: item.isSelected ? "selected": ""},
        children: [item.text]
    })), element);
}