﻿
var reconnectTicks = 0;
var checkReconnectInterval;

window.showLoading = () => {
    let loadingSvg = firstOrDefault(document.body.childNodes, n => n.tagName && n.tagName.toLowerCase() === "svg" && n.classList.contains("loading"));
    if (loadingSvg) {
        loadingSvg.style.display = "unset";
    }
};

window.doneLoading = () => {
    let loadingSvg = firstOrDefault(document.body.childNodes, n => n.tagName && n.tagName.toLowerCase() === "svg" && n.classList.contains("loading"));
    if (loadingSvg) {
        loadingSvg.style.display = "none";
    }

    if (!checkReconnectInterval) {
        checkReconnectInterval = setInterval(() => {
            if (isReconnectVisible()) {
                reconnectTicks++;
                if (reconnectTicks > 3) {
                    let div = document.getElementById("components-reconnect-modal");
                    if (div) {
                        let childDiv = firstOrDefault(div.childNodes, n => n.tagName && n.tagName.toLowerCase() === "div");
                        let svg = firstOrDefault(childDiv.childNodes, n => n.tagName && n.tagName.toLowerCase() === "svg");
                        let info = firstOrDefault(childDiv.childNodes, n => n.tagName && n.tagName.toLowerCase() === "div" && n.classList.contains("info"));
                        if (svg)
                            svg.style.display = "none";
                        if (info)
                            info.style.display = "block";
                        clearInterval(checkReconnectInterval);
                    }
                }
            }
            else {
                reconnectTicks = 0;
            }
        }, 2000);
    }
};

function isReconnectVisible() {
    let div = document.getElementById("components-reconnect-modal");
    if (div) {
        let style = window.getComputedStyle(div);
        if (style.display !== "none") {
            return true;
        }
    }

    return false;
}


//var ongoingActions = [];
//var progressIndicator = null;
//var progressTimer;

//window.startingAction = action => {
//    ongoingActions.push(action);
//    if (!progressIndicator) {
//        progressIndicator = document.createElement("div");
//        progressIndicator.style = "position: fixed; bottom: 0; left: 0; right: 0; display: flex; flex-direction: column; ";
//        progressIndicator.innerHTML = `<div style="background: #1267fc; position: relative; height: 6px; "><div class="whiteBar" style="background: linear-gradient(to right, transparent, white, transparent); width: 100%; position: absolute; left: 25%; height: 100%; "></div><div class="whiteBar2" style="background: linear-gradient(to right, transparent, white, transparent); width: 100%; position: absolute; left: -75%; height: 100%; "></div></div>`;
//        document.body.appendChild(progressIndicator);
//        let whiteBar = progressIndicator.getElementsByClassName("whiteBar")[0];
//        let whiteBar2 = progressIndicator.getElementsByClassName("whiteBar2")[0];
//        progressTimer = setInterval(() => {
//            let x = whiteBar.offsetLeft + 40;
//            let x2 = whiteBar2.offsetLeft + 40;
//            if (x > progressIndicator.offsetWidth)
//                x = -whiteBar.offsetWidth;
//            if (x2 > progressIndicator.offsetWidth)
//                x2 = -whiteBar.offsetWidth;
//            whiteBar.style.left = `${x}px`;
//            whiteBar2.style.left = `${x2}px`;
//        }, 25);
//    }
//};

//window.finishingAction = action => {
//    removeFromArray(action, ongoingActions);
//    if (progressIndicator && ongoingActions.length === 0) {
//        document.body.removeChild(progressIndicator);
//        progressIndicator = null;
//        clearInterval(progressTimer);
//    }
//};
