﻿
window.sendRequest = function (request, url, responseType, callback) {
    try {
        var httpRequest = new XMLHttpRequest();
        httpRequest.open("POST", url);
        httpRequest.setRequestHeader("Content-type", "application/json;charset=UTF-8");
        httpRequest.onreadystatechange = function () {
            if (httpRequest.readyState === XMLHttpRequest.DONE) {
                let response = {};
                try {
                    response = JSON.parse(httpRequest.responseText);
                }
                catch { }
                if (httpRequest.status === 200) {
                    try {
                        if (response.error)
                            callback(response, response.error);
                        else if (response.type !== responseType)
                            callback(response, "Invalid response type");
                        else
                            callback(response);
                    }
                    catch (ex) {
                        callback(response, ex);
                    }
                }
                else {
                    callback(response, "Error " + httpRequest.status);
                }
            }
        };
        httpRequest.send(JSON.stringify(request));
    }
    catch {
        callback(undefined, "Error");
    }
};

window.submitFormSilent = function (form) {
    return new Promise((resolve, reject) => {
        var url = form.getAttribute("action");
        var request = new XMLHttpRequest();
        request.open("POST", url, true);
        request.onload = function () {
            resolve();
        };
        request.onerror = function () {
            reject();
        };
        request.send(new FormData(form));
    });
};