﻿import { getMainWindowId } from "./helpers.js";

if (window.require) {
    const electron = require("electron");
    const ipcRenderer = electron.ipcRenderer;

    window.confirmClose = {
        closeTabs: async () => {
            let urlParams = new URLSearchParams(window.location.search);
            let tabIds = urlParams.getAll("tab");
            if (tabIds.length === 0) {
                ipcRenderer.invoke("close-main-window", getMainWindowId());
            }
            else {
                DotNet.invokeMethodAsync("Blockpad", "MainWindowCloseTabs", getMainWindowId().toString(), tabIds);
                window.close();
            }
        },
        keepTabsOpen: () => {
            window.close();
            ipcRenderer.invoke("prevent-quit");
        }
    };

    window.showCloseDialog = (mainWindowId, tabIds) => {
        ipcRenderer.invoke("show-close-dialog", mainWindowId, tabIds);
    };
}

const isElectron = typeof process === 'object' &&
    typeof process.versions === 'object' &&
    !!process.versions.electron;

if (window.parent?.location?.pathname === "/app/workspace") {
    if (!isElectron) {
        window.addEventListener("beforeunload", (e) => {
            e.preventDefault();
        });
    }
}