﻿import { getMainWindowId } from "./helpers.js";

if (window.require) {
    const electron = require("electron");
    const ipcRenderer = electron.ipcRenderer;

    window.promptFolder = () => {
        return ipcRenderer.invoke("prompt-folder", getMainWindowId());
    };

    window.promptOpenFile = prompt => {
        return ipcRenderer.invoke("prompt-open-file", getMainWindowId(), prompt);
    };

    window.promptSaveFile = prompt => {
        return ipcRenderer.invoke("prompt-save-file", getMainWindowId(), prompt);
    };

    window.handleRecentFile = path => {
        ipcRenderer.invoke("handle-recent-file", path);
    };

    window.showMessageBox = message => {
        alert(message);
    };
}